<?php

namespace Spec\Infomaker\Everyware\Support;

use Infomaker\Everyware\Support\Fluent;
use PhpSpec\ObjectBehavior;
use Prophecy\Argument;

class FluentSpec extends ObjectBehavior
{
    public function it_is_initializable()
    {
        $this->shouldHaveType(Fluent::class);
    }

    public function it_should_have_have_constructed_keys_as_properties()
    {
        $this->beConstructedWith([
            'name' => 'John Doe',
            'age' => 30
        ]);

        $this->name->shouldReturn('John Doe');
        $this->age->shouldReturn(30);
    }

    public function it_should_have_magic_getter_and_setter() {
        $set_value = 'value';

        $this->missing_property->shouldReturn(null);
        $this->missing_property = $set_value;
        $this->get('missing_property')->shouldReturn($set_value);
        $this->missing_property->shouldReturn($set_value);
    }

    public function it_should_have_support_default_values_for_properties() {

        $this->get('missing_property', 'default_string')->shouldReturn('default_string');

    }

    public function it_should_have_support_for_closure_properties() {

        $this->set('method', $closure = function() {
            return 'return value';
        });

        $this->method->shouldReturn($closure);

    }
}
